#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

// Wyszukiwanie binarne: znajduje w tablicy X indeks s...
// ...największy taki, że X[s]<=X[k]-D.
int znajdz(vector<int> &X, int k, int D)
{
  int poczatek = 0;
  int koniec = X.size();
  while(poczatek<koniec)
  {
    int srodek = (poczatek+koniec+1)/2;
    if (X[srodek]>X[k]-D)
      koniec = srodek-1;
    else
      poczatek = srodek;
  }
  return poczatek;
}

int main()
{
  // Liczby N i D jak w treści zadania.
  int N, D;
  cin >> N >> D;
  // Ciągi X[i], C[i] jak w treści zadania.
  vector<int> X(N+1), C(N+1);
  // koszti i sumy prefiksowe mogą przekroczyć typ int;
  // Używamy zatem do nich typu long long.
  vector<long long> koszt(N+1), P(N+1);

  vector<int> podpowiedz(N+1);
  X[0] = 0;  // X[0] = 0 dla wygody późniejszego wyszukiwania.
  P[0] = 0;  // P[0] = 0 zgodnie z ustaleniami.
  for(int k=1; k<=N; k++) // Wczytujemy X[1], ..., X[N]
    cin >> X[k];
  for(int k=1; k<=N; k++) {  // Wczytujemy C[1], ..., C[N]
    cin >> C[k];
    // Od razu wyliczamy sumy prefiksowe P[1], ..., P[N].
    P[k] = P[k-1]+C[k];
  }
  koszt[0] = 0;  // Zaczynamy pętlę programowania dynamicznego.
  for(int k=1; k<=N; k++) {
    int s = znajdz(X, k, D);   // Wyszukujemy drzewo s...
    // Porównujemy wielkości z opracowania...
    if (koszt[k-1]+C[k] < koszt[s]+P[k-1]-P[s]) {
      koszt[k] = koszt[k-1]+C[k];
      podpowiedz[k] = -1;  // ...jeśli jesteś przy k-tym drzewie, wytnij je.
    } else {
      koszt[k] = koszt[s]+P[k-1]-P[s]; // ...jeśli jesteśm przy k-tym drzewie...
      podpowiedz[k] = s;               // ...pozostaw je, wytnij kolejne do s-tego.
    }
  }
  cout << koszt[N] << "\n";  // Mamy już wynik...
  vector<int> wycinka;
  int j = N;  // Odtwarzamy rozwiązanie cofając się od N:
  while (j > 0)
  {
    if (podpowiedz[j]==-1)    // Jeśli podpowiedź to -1...
    {
      wycinka.push_back(j);   // ...j-te drzewo do wycinki
      j--;                    // ...a my cofamy się do drzewa j-1.
    } else
    {
      int s = podpowiedz[j];  // Jeśli podpowiedź to s>0...
      j--;
      while(j>s)              // ...wycinamy od j-1 do s+1...
      {
        wycinka.push_back(j); // ...i cofamy się do s.
        j--;
      }
    }
  }

  cout << wycinka.size() << "\n";
  for(int i=0; i<wycinka.size(); i++)
    cout << wycinka[i] << " ";
  cout << "\n";
}
